<?
require_once("defs.php"); 
require_once("db.php");
require_once("argexp.php");

class site extends db
{
//######################
// Globals

var $notags__tags_re=""; 
var $prefix;
//######################
// Articles section

var $art_id;
var $art_topic_id;
var $art_onelistcount;
var $art_sort;
var $art_startpoint;
var $art_count;
//######################
// News section

var $last_news;
//######################
// File section

var $file_id;
var $file_count;
var $file_topic_id;
var $file_onelistcount;
var $file_sort;
var $file_startpoint;
//######################
// Link section
var $link_id;
var $link_count;
var $link_topic_id;
var $link_onelistcount;
var $link_sort;
var $link_startpoint;

//#######################
// Blog
var $blog_show;
var $blog_id;

function site()
{
 global $prefix, $id, $onelistcount, $sort, $startpoint, $newarticle, $lastnews, $lastfiles, $filelistcount, 
 $lastlinks, $linklistcount, $showblog;
 global $argx;

 $argx->to_var_by_list(
    array(
	array('id','D',0,'I'),
	array('sort','D',0,'I'),
	array('startpoint','D',0,'I'),
	),'GP');
 
 if (! is_numeric($newarticle) ) $newarticle=0;
 if (! is_numeric($lastnews) ) $lastnews=0;
 if (! is_numeric($onelistcount) ) $onelistcount=0;
 if (! is_numeric($lastfiles) ) $lastfiles=0;
 if (! is_numeric($filelistcount) ) $filelistcount=0;
 if (! is_numeric($lastlinks) ) $lastlinks=0;
 if (! is_numeric($linklistcount) ) $linklistcount=0;
 
 $this->art_id = $argx->var['id'];
 $this->art_topic_id = $argx->var['id'];
 $this->art_onelistcount = @$onelistcount;
 $this->art_sort = $argx->var['sort'];
 $this->art_startpoint = $argx->var['startpoint'];
 $this->art_count=@$newarticle;
 $this->last_news = $lastnews;
 
 $this->file_id = $argx->var['id'];
 $this->file_count = $lastfiles;
 $this->file_topic_id = $argx->var['id'];
 $this->file_onelistcount=$filelistcount;
 $this->file_sort = $argx->var['sort'];
 $this->file_startpoint = $argx->var['startpoint'];
 
 $this->link_id = $argx->var['id'];
 $this->link_count = $lastlinks;
 $this->link_topic_id = $argx->var['id'];
 $this->link_onelistcount=$linklistcount;
 $this->link_sort = $argx->var['sort'];
 $this->link_startpoint = $argx->var['startpoint'];
 
 $this->blog_show = @$showblog;
 $this->blog_id = $argx->var['id'];
 
 
 $this->prefix = $prefix;
 $this->db();
 $this->sql_connect();
 
 
 $b = array( //   -      $this 
    "[!MAIN_TOPICS_MENU_LINE!]" => 'show_main_topics_menu_line', 
    "[!MAIN_TOPICS_MENU_CAT!]" => 'show_main_topics_menu_cat', 
    "[!LAST_ARTICLES!]" => 'show_last_articles',
    "[!BEST_ARTICLES!]" => 'show_best_articles', 
    "[!SHOW_ARTICLE!]" => 'show_article', 
    "[!SHOW_ARTICLES!]" => 'show_articles',
    "[!SHOW_LAST_NEWS!]" => 'show_last_news',
    "[!LAST_FILES!]" => 'show_last_files', 
    "[!SHOW_FILES!]" => 'show_files',
    "[!BEST_FILES!]" => 'show_best_files',
    "[!MAIN_FILES_MENU_LINE!]" => 'show_main_file_menu_line', 
    "[!MAIN_FILES_MENU_CAT!]" => 'show_main_file_menu_cat',
    "[!DOWNLOAD!]" => 'download',
    "[!SHOW_LINKS!]" => 'show_links',
    "[!BEST_LINKS!]" => 'show_best_links',
    "[!LAST_LINKS!]" => 'show_last_links',
    "[!MAIN_LINK_MENU_LINE!]" => 'show_main_link_menu_line', 
    "[!MAIN_LINK_MENU_CAT!]" => 'show_main_link_menu_cat',
    "[!SHOW_STATS!]" => 'show_stats',
    "[!SHOW_BLOG!]" => 'show_blog',
    "[!VIEW_BLOG!]" => 'view_blog'
    ); 

//    
 $a=array_keys($b); 
 $re='('.preg_quote(reset($a)); 
 for($v=next($a);$v;$v=next($a)) $re.='|'.preg_quote($v); 
 $re.=')'; 

 $this->regexp=&$re; //    -   -     
 $this->func_arr = &$b; 
}




function deinit()
{
    $this->sql_close();
}


function load_template($file_name)
{
    $file_tpl=fopen($file_name,'r');
    $text=fread($file_tpl,filesize($file_name));	
    fclose($file_tpl);
    return $text;
}

function replace_template2($match)
{ 
    return call_user_func(array(&$this,$this->func_arr[$match[0]])); 
} 

function replace_template($text)
{ 
    return preg_replace_callback($this->regexp,array(&$this,'replace_template2'),$text); 
} 




function show_main_topics_menu_cat()
{
    $res = $this->sql_query("SELECT * from ".$this->prefix."topics WHERE prev=0 ORDER BY accessnum ASC");

    if (!$res) return "";

    $result="<table width=100% border=0 cellspacing=0 cellpadding=0 class=topicmenucat>";
    $temp = "";
    while (1)
    {
	$myrow = mysql_fetch_array(@$res);
	if (!$myrow) break;

		$name = stripslashes($myrow["name"]);
		$descr = stripslashes($myrow["descr"]);
		$id = $myrow["id"];
		
	$temp = $temp."<tr><td width = 50% valign = top>";
	
	$temp = $temp."<a href=view.php?id=$id title='$descr'><font size=2><b>$name</b></font></a><br>";
	
	$res2 = $this->sql_query("SELECT * from ".$this->prefix."topics WHERE prev=$id ORDER BY accessnum ASC");
		
                while ($myrow2 = mysql_fetch_array($res2))
		{
			$name2 = stripslashes($myrow2["name"]);
			$descr2 = stripslashes($myrow2["descr"]);
			$id2 = $myrow2["id"];	
			$temp= $temp."   <a href=view.php?id=$id2 title='$descr2'><font size=1>".$name2."</font></a> : ";	
		}

	
	
	$myrow = mysql_fetch_array($res);
	if (!$myrow){
	$temp=$temp."</td></tr>";
	break;
	}
		
		$name = stripslashes($myrow["name"]);
		$descr = stripslashes($myrow["descr"]);
		$id = $myrow["id"];
		
	$temp = $temp."</td><td width = 50% valign = top>";
	$temp = $temp."<a href=view.php?id=$id title='$descr'><font size=2><b>$name</b></font></a><br>";
	
	$res2 = $this->sql_query("SELECT * from ".$this->prefix."topics WHERE prev=$id ORDER BY accessnum ASC");
		
        while ($myrow2 = mysql_fetch_array($res2))
		{
			$name2 = stripslashes($myrow2["name"]);
			$descr2 = stripslashes($myrow2["descr"]);
			$id2 = $myrow2["id"];	
			$temp= $temp."   <a href=view.php?id=$id2 title='$descr2'><font size=1>".$name2."</font></a> : ";	
		}

	$temp = $temp."</td></tr>";

	}

	$result=$result.$temp;
	$result=$result."</table>";
	return $result;
}


function show_main_topics_menu_line()
{

    $res = $this->sql_query("SELECT * from ".$this->prefix."topics WHERE prev=0 ORDER BY accessnum ASC");

    $result="<table width = 100%>";

    while (@$myrow = mysql_fetch_array($res))
    {
	$name = stripslashes($myrow["name"]);
	$descr = stripslashes($myrow["descr"]);
	$id = $myrow["id"];
	if ($this->art_topic_id == $id)
	{
	    $result= $result."<tr><td height=24>"."<a href=view.php?id=$id title='$descr'><b>$name</b></a><br>"."</td></tr>";
	}
	else
	{
	    $result= $result."<tr><td height=24>"."<a href=view.php?id=$id title='$descr'>$name</a><br>"."</td></tr>";
	}
	$res2 = $this->sql_query("SELECT * from ".$this->prefix."topics WHERE prev=$id ORDER BY accessnum ASC");
	$result=$result."<tr><td><pre>";

    while ($myrow2 = mysql_fetch_array($res2))
	{
	    $name2 = stripslashes($myrow2["name"]);
	    $descr2 = stripslashes($myrow2["descr"]);
	    $id2 = $myrow2["id"];
	    if ($this->art_topic_id == $id2)
	    {
		$result= $result."   <a href=view.php?id=$id2 title='$descr2'><b>".$name2."</b></a><br>";	
	    }
	    else
	    {
		$result= $result."   <a href=view.php?id=$id2 title='$descr2'>".$name2."</a><br>";	
	    }
	}
	$result=$result."</td></tr></pre>";
    }

    $result=$result."</table>";

    return $result;
}

function show_last_articles()
{
    $i=0;
    $result="<table width=100% cellspacing=0 cellpadding=0 border=0>";

    $res = $this->sql_query("SELECT id, nameoftxt, descript from ".$this->prefix."articles ORDER BY id DESC LIMIT 0,$this->art_count");
    while (@$myrow = mysql_fetch_array($res))
    {
	$name = stripslashes($myrow["nameoftxt"]);
	$descr = stripslashes($myrow["descript"]);
	$id = $myrow["id"];
	if ($i==0) { $i=1; } else{ $i=0; }
	$result=$result."<tr><td height=24><div class='marg'>"."<a href=viewart.php?id=$id title='$descr'>$name</a>"."</div><hr size=1 width=100% NOSHADE align=left color=#a5a5a5></td></tr>";
    }
    $result=$result."</table>";
    return $result;
}

function show_best_articles()
{
    $i=0;
    $result="<table width=100% cellspacing=0 cellpadding=0 border=0>";

    $res = $this->sql_query("SELECT id, nameoftxt, descript from ".$this->prefix."articles ORDER BY count_view DESC LIMIT 0,$this->art_count");
    while (@$myrow = mysql_fetch_array($res))
    {
	$name = stripslashes($myrow["nameoftxt"]);
	$descr = stripslashes($myrow["descript"]);
	$id = $myrow["id"];
	if ($i==0) { $i=1; } else { $i=0; }
	$result=$result."<tr><td height=24><div class='marg'>"."<a href=viewart.php?id=$id title='$descr'>$name</a>"."</div></td></tr>";
    }
    $result=$result."</table>";
    return $result;
}


# 
# $notags__tags_re - global var. 
# notags_init()   - make $notags__tags_re . 
# notags_correct($str) - returns fixed string. 
# 

###################### 



function notags_init() { 
    static $tags=array( # HTML 4.0 tags 
   "A", 
   "ABBR", 
   "ACRONYM", 
   "ADDRESS", 
#   "APPLET", 
#   "AREA", 
   "B", 
#   "BASE", 
#   "BASEFONT", 
#   "BDO", 
   "BIG", 
   "BLOCKQUOTE", 
#   "BODY", 
   "BR", 
#   "BUTTON", 
   "CAPTION", 
   "CENTER", 
   "CITE", 
   "CODE", 
#   "COL", 
#   "COLGROUP", 
   "DD", 
   "DEL", 
   "DFN", 
   "DIR", 
   "DIV", 
   "DL", 
   "DT", 
   "EM", 
#   "FIELDSET", 
   "FONT", 
   "FORM", 
#   "FRAME", 
#   "FRAMESET", 
   "H1", 
   "H2", 
   "H3", 
   "H4", 
   "H5", 
   "H6", 
#   "HEAD", 
   "HR", 
#   "HTML", 
   "I", 
   "IFRAME", 
   "IMG", 
#   "INPUT", 
   "INS", 
#   "ISINDEX", 
#   "KBD", 
#   "LABEL", 
#   "LEGEND", 
   "LI", 
#   "LINK", 
#   "MAP", 
#   "MENU", 
#   "META", 
#   "NOFRAMES", 
#   "NOSCRIPT", 
#   "OBJECT", 
   "OL", 
#   "OPTGROUP", 
#   "OPTION", 
   "P", 
#   "PARAM", 
   "PRE", 
   "Q", 
   "S", 
   "SAMP", 
#   "SCRIPT", 
#   "SELECT", 
   "SMALL", 
   "SPAN", 
   "STRIKE", 
   "STRONG", 
#   "STYLE", 
   "SUB", 
   "SUP", 
   "TABLE", 
#   "TBODY", 
   "TD", 
   "TEXTAREA", 
#   "TFOOT", 
   "TH", 
#   "THEAD", 
#   "TITLE", 
   "TR", 
   "TT", 
   "U", 
   "UL",
   "XMP"
#   "VAR" 
   ); 
    global $notags__tags_re; 

    $s=$tags[0]; 
    $l=count($tags); 
    for($i=1;$i<$l;$i++) $s.="|$tags[$i]"; 
    $notags__tags_re=$s; 
    } 

function notags_correct($str) { 
    global $notags__tags_re; 

    $a=preg_split('%(<[^<]+>|&#?\w+;)%',$str,-1,PREG_SPLIT_DELIM_CAPTURE); 

    foreach($a as $n => $v) { 
   $f=1; 
   if(substr($v,0,1)=='<') { 
       if(preg_match('%^</?('."$notags__tags_re".')(\s+[\w.]+(?:\s*=\s*"?[^"]*"?)?)*\s*/?>$%i',$v)) $f=0; 

       } 
   elseif(substr($v,0,1)=='&' && substr($v,strlen($v)-1,1)==';') { 
//... 
       $f=0; 
       } 
 /*  if($f) { 
       $v=preg_replace('/&/','&amp;',$v); 
       $v=preg_replace('/</','&lt;',$v); 
       $v=preg_replace('/>/','&gt;',$v); 
       $v=preg_replace('/"/','&quot;',$v); 
       $a[$n]=$v; 
       } */
   } 
    return join($a,''); 
    } 


function show_article() 
{
	$res = $this->sql_query("SELECT * from ".$this->prefix."articles WHERE id=$this->art_id");
	if (!@res) die ('Id unknown.');

	@$myrow = mysql_fetch_array($res);
	$count = $myrow["count_view"];
	$name = $myrow["nameoftxt"];
	$descr = $myrow["descript"];
	$email = $myrow["authoremail"];
	$author = $myrow["authorname"];
	$text = $myrow["text"];
	$tag_style = $myrow["tag_style"];
	if ($count != -1)
	{
		$count=$count+1;
	}
	$name = stripslashes($name);
	$descr = stripslashes($descr);
	$email = stripslashes($email);
	$author= stripslashes($author);
//	$txt = stripslashes($txt);

//	$this->notags_init();
//	$txt = $this->notags_correct($txt);	

	include("tags1.php");
	$tags = new tags1;
	$tags->set_tag_style($tag_style);
	$tags->set_nl2br('pre');
	$text = $tags->encode($text);

	$res = $this->sql_query("UPDATE ".$this->prefix."articles SET count_view='$count' WHERE id=$this->art_id");		

//	$text = str_replace("\r\n","<br>\n","$txt");
	$result = "<table border=0 width=99%><tr><td align=left valign=top colspan=2>"."<h3 align=left>$name</h3></td></tr>".
	"<tr><td align=left valign=top>: <a href=mailto:$email>$author</a><br>".": $count<br><br>".
	/*       -   */"</td><td align=right valign=top></td></tr></table>".
	"<table border=0 width=99%><tr><td align=justify valign=top><tr><td><div class = txt>".
	$text.
	"</div></td></tr></table>".
	"</div><table border=0 width=99%><tr><td ><a href=print.php?id=$this->art_id>  </td><td align=right valign=top>".
	/*       -   */"</td></tr></table>";
	return $result;
}

function show_articles()
{
	$id_pressed = $this->art_topic_id;
	$tempid = $this->art_topic_id;
	$onelistcount = $this->art_onelistcount;
	$sort = $this->art_sort;
	$startpoint = $this->art_startpoint;

	//    
	//******************************
	$res = $this->sql_query("SELECT COUNT(*) FROM ".$this->prefix."articles WHERE id_topics=$id_pressed");
	echo $this->sql_err;
	$itms = mysql_fetch_array($res);
	$total = $itms[0];
	$pages = floor($total/$onelistcount);
	$page= $total/$onelistcount;
	if ($page>$pages){$pages++;}

	//   
	//******************************

	if ($sort==1)
	{
		$sql_res = $this->sql_query("SELECT id,nameoftxt,authorname, authoremail, descript, count_view from ".$this->prefix."articles WHERE id_topics=$id_pressed ORDER BY nameoftxt ASC LIMIT $startpoint,$onelistcount");
	}
	else if ($sort==2)
	{
		$sql_res = $this->sql_query("SELECT id,nameoftxt,authorname, authoremail, descript, count_view from ".$this->prefix."articles WHERE id_topics=$id_pressed ORDER BY authorname ASC LIMIT $startpoint,$onelistcount");			
	} 
	else if ($sort==3)
	{
		$sql_res = $this->sql_query("SELECT id,nameoftxt,authorname, authoremail, descript, count_view from ".$this->prefix."articles WHERE id_topics=$id_pressed ORDER BY count_view DESC LIMIT $startpoint,$onelistcount");			
	} else
	{
		$sql_res = $this->sql_query("SELECT id,nameoftxt,authorname, authoremail, descript, count_view from ".$this->prefix."articles WHERE id_topics=$id_pressed ORDER BY id DESC LIMIT $startpoint,$onelistcount");
	}


	$result = "<table width = 99% cellspacing=0 cellpadding=0 border=0>
	<tr><td height=24 width=40% align=center valign=middle><a href=view.php?id=".$id_pressed."&sort=1 title=''></a></td>
	<td height=24 width=5% align=center valign=middle><a href=view.php?id=".$id_pressed."&sort=2 title=''></a></td>
	<td height=24 width = 50% align=center valign=middle></td>
	<td height=24 width = 5% align=center valign=middle><a href=view.php?id=".$id_pressed."&sort=3 title=''></a></td>
	</tr>
	<tr><td bgcolor =000000 height=1></td>
	<td bgcolor = 000000 height=1></td>
	<td bgcolor = 000000 height=1></td>
	<td bgcolor = 000000 height=1></td>
	</tr>";

	$i=1;

	while ($myrow = mysql_fetch_array($sql_res))
	{
		$name = stripslashes($myrow["nameoftxt"]);
		$descr = stripslashes($myrow["descript"]);
		$email = stripslashes($myrow["authoremail"]);
		$author= stripslashes($myrow["authorname"]);
		$count = $myrow["count_view"];
		$id = $myrow["id"];

		if ($i==0){$i=1;} else{$i=0;}
		
		$result = $result."<tr><td height=24><div class=main>"
		."<a href=viewart.php?id=$id>$name</a>"
		."</div></td>
		
		<td  height=24><div class=main>"
		."<a href=mailto:$email>$author</a>"
		."</div></td>
		
		<td height=24><div class=main>"
		."<font size = 1>$descr</font>"
		."</div></td>
		
		<td height=24><div class=main>"
		."<font size = 1> $count</NOBR></font>";
		
		$result = $result."</div></td></tr>";
	}

	$result = $result."</table>";

	$result = $result."<table width = 99% border=0><tr><td align=left>: ";

	for($i=1; $i<=$pages; $i++)
	{
		$next=($i-1)*$onelistcount;
		if ($i == ($startpoint/$onelistcount)+1)
		{
			$result = $result."<b>".$i."</b> ";
		}
		else
		{
			$result = $result."<a href=view.php?id=$tempid&startpoint=$next&sort=$sort>".$i."</a>";
		}
	}
	$result = $result."</td></tr></table>";
	return $result;
}

function show_last_news()
{
	$res = $this->sql_query("SELECT * from ".$this->prefix."news ORDER BY id DESC LIMIT 0,$this->last_news");
	if (!$res) return "";
	$result = "";
	while ($myrow = mysql_fetch_array($res))
	{
		$txt = stripslashes($myrow["text"]);
		$date = $myrow["date"];
		$result = $result."<b>".$date."</b><br>".$txt."<br><br>";
	}
	return $result;
}

// ##############################################################################################
// File section
// ##############################################################################################
function show_last_files()
{

    $i=0;
    $result="<table width=100%>";

    $res = $this->sql_query("SELECT * from ".$this->prefix."files ORDER BY id DESC LIMIT 0,$this->file_count");
    while (@$myrow = mysql_fetch_array($res))
    {
	$name = stripslashes($myrow["filename"]);
	$descr = stripslashes($myrow["descr"]);
	$id = $myrow["id"];
	if ($i==0) { $i=1; } else { $i=0; }
	$result=$result."<tr><td height=24><div class = marg>"."<a href=download.php?id=$id title='$descr' target = _download>$name</a><br>"."</div><hr size=1 width=100% NOSHADE align=left color=#a5a5a5></td></tr>";
    }
    $result=$result."</table>";
    return $result;
}

function show_files()
{
	
	$id_pressed = $this->file_topic_id;
	$tempid = $this->file_topic_id;
	$onelistcount = $this->file_onelistcount;
	$sort = $this->file_sort;
	$startpoint = $this->file_startpoint;

		//    
		//******************************
		$res = $this->sql_query("SELECT COUNT(*) FROM ".$this->prefix."files WHERE id_topic=$id_pressed");
		echo $this->sql_err;
		$itms = mysql_fetch_array($res);
		$total = $itms[0];
		$pages = floor($total/$onelistcount);
		$page= $total/$onelistcount;
		if ($page>$pages){$pages++;}
		
		//   
		//******************************
			
		if ($sort==1)
		{
			$sql_res = $this->sql_query("SELECT * from ".$this->prefix."files WHERE id_topic=$id_pressed ORDER BY filename ASC LIMIT $startpoint,$onelistcount");
		}
		else if ($sort==2)
		{
			$sql_res = $this->sql_query("SELECT * from ".$this->prefix."files WHERE id_topic=$id_pressed ORDER BY authorname ASC LIMIT $startpoint,$onelistcount");			
		} 
		else if ($sort==3)
		{
			$sql_res = $this->sql_query("SELECT * from ".$this->prefix."files WHERE id_topic=$id_pressed ORDER BY count_view DESC LIMIT $startpoint,$onelistcount");			
		} else
		{
			$sql_res = $this->sql_query("SELECT * from ".$this->prefix."files WHERE id_topic=$id_pressed ORDER BY id DESC LIMIT $startpoint,$onelistcount");
		}


	$result = "<table width = 100% cellspacing=0 cellpadding=0 border=0>
	<tr><td bgcolor =FFFFFF height=24 width=40% align=center valign=middle><a href=viewfiles.php?id=".$id_pressed."&sort=1 title=''></a></td>
	<td bgcolor = FFFFFF height=24 width=5% align=center valign=middle><a href=viewfiles.php?id=".$id_pressed."&sort=2 title=''></a></td>
	<td bgcolor = FFFFFF height=24 width = 50% align=center valign=middle></td>
	<td bgcolor = FFFFFF height=24 width = 5% align=center valign=middle><a href=viewfiles.php?id=".$id_pressed."&sort=3 title=''></a></td>
	</tr>
	<tr><td bgcolor =000000 height=1></td>
	<td bgcolor = 000000 height=1></td>
	<td bgcolor = 000000 height=1></td>
	<td bgcolor = 000000 height=1></td>
	</tr>";
	
	
	$i=1;

	while ($myrow = mysql_fetch_array($sql_res))
	{
		$name = stripslashes($myrow["filename"]);
		$descr = stripslashes($myrow["descr"]);
		$email = stripslashes($myrow["authoremail"]);
		$author= stripslashes($myrow["authorname"]);
		$count = $myrow["count_view"];
		$id = $myrow["id"];
				
		if ($i==0){$i=1;} else{$i=0;}
		
		$result = $result."<tr><td  height=24><div class=main>"
		."<a href=download.php?id=$id target=_download>$name</a>"
		."</div></td><td  height=24><div class=main>"
		."<a href=mailto:$email>$author</a>"
		."</div></td><td height=24><div class=main>"
		."<font size = 1>$descr</font>"
		."</div></td><td height=24><div class=main>"
		."<font size = 1> $count</NOBR></font>";
	}
	$result = $result."</div></td></tr>";
	
	$result = $result."</table>";
	$result = $result."<table width=99% border=0><tr><td align=left>";
	$result = $result.": ";
	
	for($i=1; $i<=$pages; $i++)
	{
		$next=($i-1)*$onelistcount;
		if ($i == ($startpoint/$onelistcount)+1)
		{
			$result = $result."<b>".$i."</b> ";
		}
		else
		{
			$result = $result."<a href=viewfiles.php?id=$tempid&startpoint=$next&sort=$sort>".$i."</a> ";
		}
	}
	$result = $result."</td></tr></table>";
	return $result;
}

function show_main_file_menu_line()
{ 
    $res = $this->sql_query("SELECT * from ".$this->prefix."filetopics WHERE prev=0 ORDER BY accessnum ASC");

    $result="<table width = 100% border=0>";


    while (@$myrow = mysql_fetch_array($res))
    {
	$name = stripslashes($myrow["name"]);
	$descr = stripslashes($myrow["descr"]);
	$id = $myrow["id"];
	if ($this->file_topic_id == $id)
	{
		$result= $result."<tr><td height=24>"."<a href=viewfiles.php?id=$id title='$descr'><b>$name</b></a><br>"."</td></tr>";
	}
	else
	{
		$result= $result."<tr><td height=24>"."<a href=viewfiles.php?id=$id title='$descr'>$name</a><br>"."</td></tr>";
	}
	$res2 = $this->sql_query("SELECT * from ".$this->prefix."filetopics WHERE prev=$id ORDER BY accessnum ASC");
	$result=$result."<tr><td><pre>";
        while ($myrow2 = mysql_fetch_array($res2))
	{
		$name2 = stripslashes($myrow2["name"]);
		$descr2 = stripslashes($myrow2["descr"]);
		$id2 = $myrow2["id"];
		if ($this->file_topic_id == $id2)
		{
			$result= $result."   <a href=viewfiles.php?id=$id2 title='$descr2'><b>".$name2."</b></a><br>";	
		}
		else
		{
			$result= $result."   <a href=viewfiles.php?id=$id2 title='$descr2'>".$name2."</a><br>";	
		}
	}
	$result=$result."</td></tr></pre>";
    }
    $result=$result."</table>";
    return $result;
}

function show_main_file_menu_cat()
{
    $res = $this->sql_query("SELECT * from ".$this->prefix."filetopics WHERE prev=0 ORDER BY accessnum ASC");

    if (!$res) return "";

    $result="<table width=100% border=0 cellspacing=0 cellpadding=0 class=topicmenucat>";
    while (1)
    {
	$myrow = mysql_fetch_array(@$res);
	if (!$myrow) break;
	$name = stripslashes($myrow["name"]);
	$descr = stripslashes($myrow["descr"]);
	$id = $myrow["id"];
		
	$result = $result."<tr><td width = 50% valign = top>";
	
	$result = $result."<a href=viewfiles.php?id=$id title='$descr'><font size=2><b>$name</b></font></a><br>";
	
	$res2 = $this->sql_query("SELECT * from ".$this->prefix."filetopics WHERE prev=$id ORDER BY accessnum ASC");
		
        while ($myrow2 = mysql_fetch_array($res2))
	{
		$name2 = stripslashes($myrow2["name"]);
		$descr2 = stripslashes($myrow2["descr"]);
		$id2 = $myrow2["id"];	
		$result= $result."   <a href=viewfiles.php?id=$id2 title='$descr2'><font size=1>".$name2."</font></a> : ";	
	}

	$result = $result."</td><td width = 50% valign = top>";
	
	$myrow = mysql_fetch_array($res);
	if (!$myrow) break;
	$name = stripslashes($myrow["name"]);
	$descr = stripslashes($myrow["descr"]);
	$id = $myrow["id"];
	
	$result = $result."<a href=viewfiles.php?id=$id title='$descr'><font size=2><b>$name</b></font></a><br>";
	
	$res2 = $this->sql_query("SELECT * from ".$this->prefix."filetopics WHERE prev=$id ORDER BY accessnum ASC");
		
        while ($myrow2 = mysql_fetch_array($res2))
	{
		$name2 = stripslashes($myrow2["name"]);
		$descr2 = stripslashes($myrow2["descr"]);
		$id2 = $myrow2["id"];	
		$result= $result."   <a href=viewfiles.php?id=$id2 title='$descr2'><font size=1>".$name2."</font></a> : ";	
	}

	$result = $result."</td></tr>";
    }

    $result=$result."</table>";
    return $result;
}

function download()
{
	$res = $this->sql_query("SELECT * from ".$this->prefix."files WHERE id=$this->file_id");
	if (!$res) return "";
	$myrow = mysql_fetch_array($res);
	
	$name = stripslashes($myrow["filename"]);
	$descr = stripslashes($myrow["descr"]);
	$email = stripslashes($myrow["authoremail"]);
	$author= stripslashes($myrow["authorname"]);
	$count = $myrow["count_view"];
	$size = $myrow["size"];
	$lang = $myrow["lang"];
	$url = $myrow["url"];
	
	$result = "<table width=100%><tr><td>";
	$result = $result.": ".$name."</td></tr><tr><td>";
	$result = $result.": ".$descr."</td></tr><tr><td>";
	$result = $result.": <a href=mailto:".$email.">".$author."</a></td></tr><tr><td>";
	$result = $result." : ".$count."</td></tr><tr><td>";
	$result = $result." : ".$size."</td></tr><tr><td>";
	$result = $result." ( ): ".$lang."</td></tr></table>";
	$result = $result."<center><a href=".$url."><font size=3>     </font></a></center>";
	
	$count++;
	$this->sql_query("UPDATE ".$this->prefix."files SET count_view='$count' WHERE id=$this->file_id");
	$result=$result."<meta http-equiv=refresh content='3; url=".$url."'>";
	return $result;
}

function show_best_files()
{
    $i=0;
    $result="<table width=100% cellspacing=0 cellpadding=0 border=0>";

    $res = $this->sql_query("SELECT id, filename, descr from ".$this->prefix."files ORDER BY count_view DESC LIMIT 0,$this->file_count");
    while (@$myrow = mysql_fetch_array($res))
    {
	$name = stripslashes($myrow["filename"]);
	$descr = stripslashes($myrow["descr"]);
	$id = $myrow["id"];
	if ($i==0){$i=1;} else{$i=0;}
	$result=$result."<tr><td height=24><div class='marg'>"."<a href=download.php?id=$id title='$descr' target = _download>$name</a>"."</div></td></tr>";
    }
    $result=$result."</table>";
    return $result;
}

// ##############################################################################################
// Link section
// ##############################################################################################

function show_main_link_menu_cat()
{
    $res = $this->sql_query("SELECT * from ".$this->prefix."linktopics WHERE prev=0 ORDER BY accessnum ASC");

    $result="<table width=100%>";
     
    while (1)
    {
	$myrow = mysql_fetch_array(@$res);
	if (!$myrow) break;
	$name = stripslashes($myrow["name"]);
	$descr = stripslashes($myrow["descr"]);
	$id = $myrow["id"];
		
	$result = $result."<tr><td width = 50% valign = top>";
	
	$result = $result."<a href=viewlinks.php?id=$id title='$descr'><font size=2><b>$name</b></font></a><br>";
	
	$res2 = $this->sql_query("SELECT * from ".$this->prefix."linktopics WHERE prev=$id ORDER BY accessnum ASC");
		
        while ($myrow2 = mysql_fetch_array($res2))
	{
		$name2 = stripslashes($myrow2["name"]);
		$descr2 = stripslashes($myrow2["descr"]);
		$id2 = $myrow2["id"];	
		$result= $result."   <a href=viewlinks.php?id=$id2 title='$descr2'><font size=1>".$name2."</font></a> : ";	
	}

	$result = $result."</td><td width = 50% valign = top>";
	
	$myrow = mysql_fetch_array($res);
	if (!$myrow) break;
	if (!$myrow) break;
	$name = stripslashes($myrow["name"]);
	$descr = stripslashes($myrow["descr"]);
	$id = $myrow["id"];
	
	$result = $result."<a href=viewlinks.php?id=$id title='$descr'><font size=2><b>$name</b></font></a><br>";
	
	$res2 = $this->sql_query("SELECT * from ".$this->prefix."linktopics WHERE prev=$id ORDER BY accessnum ASC");
		
        while ($myrow2 = mysql_fetch_array($res2))
	{
		$name2 = stripslashes($myrow2["name"]);
		$descr2 = stripslashes($myrow2["descr"]);
		$id2 = $myrow2["id"];	
		$result= $result."   <a href=viewlinks.php?id=$id2 title='$descr2'><font size=1>".$name2."</font></a> : ";	
	}

	$result = $result."</td></tr>";
    }

    $result=$result."</table>";
    return $result;
}

function show_main_link_menu_line()
{
    $res = $this->sql_query("SELECT * from ".$this->prefix."linktopics WHERE prev=0 ORDER BY accessnum ASC");

    $result="<table width=100% border=0 cellspacing=0 cellpadding=0>";

    while (@$myrow = mysql_fetch_array($res))
    {
	$name = stripslashes($myrow["name"]);
	$descr = stripslashes($myrow["descr"]);
	$id = $myrow["id"];
	if ($this->link_topic_id == $id)
	{
		$result= $result."<tr><td height=24>"."<a href=viewlinks.php?id=$id title='$descr'><b>$name</b></a><br>"."</td></tr>";
	}
	else
	{
		$result= $result."<tr><td height=24>"."<a href=viewlinks.php?id=$id title='$descr'>$name</a><br>"."</td></tr>";
	}
	$res2 = $this->sql_query("SELECT * from ".$this->prefix."linktopics WHERE prev=$id ORDER BY accessnum ASC");
	$result=$result."<tr><td><pre>";
	while ($myrow2 = mysql_fetch_array($res2))
	{
	    $name2 = stripslashes($myrow2["name"]);
	    $descr2 = stripslashes($myrow2["descr"]);
	    $id2 = $myrow2["id"];
	    if ($this->link_topic_id == $id2)
	    {
		$result= $result."   <a href=viewlinks.php?id=$id2 title='$descr2'><b>".$name2."</b></a><br>";	
	    }
	    else
	    {
		$result= $result."   <a href=viewlinks.php?id=$id2 title='$descr2'>".$name2."</a><br>";	
	    }
	}
	$result=$result."</td></tr></pre>";
    }
    $result=$result."</table>";
    return $result;
}

function show_links()
{
	$id_pressed = $this->link_topic_id;
	$tempid = $this->link_topic_id;
	$onelistcount = $this->link_onelistcount;
	$sort = $this->link_sort;
	$startpoint = $this->link_startpoint;

	//    
	//******************************
	$res = $this->sql_query("SELECT COUNT(*) FROM ".$this->prefix."links WHERE id_topic=$id_pressed");
	echo $this->sql_err;
	$itms = mysql_fetch_array($res);
	$total = $itms[0];
	$pages = floor($total/$onelistcount);
	$page= $total/$onelistcount;
	if ($page>$pages){$pages++;}
		
	//   
	//******************************
			
	if ($sort==1)
	{
		$sql_res = $this->sql_query("SELECT * from ".$this->prefix."links WHERE id_topic=$id_pressed ORDER BY filename ASC LIMIT $startpoint,$onelistcount");
	}
	else if ($sort==2)
	{
		$sql_res = $this->sql_query("SELECT * from ".$this->prefix."links WHERE id_topic=$id_pressed ORDER BY authorname ASC LIMIT $startpoint,$onelistcount");			
	} 
	else if ($sort==3)
	{
		$sql_res = $this->sql_query("SELECT * from ".$this->prefix."links WHERE id_topic=$id_pressed ORDER BY count_view DESC LIMIT $startpoint,$onelistcount");			
	} else
	{
		$sql_res = $this->sql_query("SELECT * from ".$this->prefix."links WHERE id_topic=$id_pressed ORDER BY id DESC LIMIT $startpoint,$onelistcount");
	}


	$result = "<table width = 100% cellspacing=0 cellpadding=0 border=0>
	<tr><td bgcolor =FFFFFF height=24 width=40% align=center valign=middle><a href=viewlinks.php?id=".$id_pressed."&sort=1 title=''></a></td>
	<td bgcolor = FFFFFF height=24 width=5% align=center valign=middle><a href=viewlinks.php?id=".$id_pressed."&sort=2 title=''></a></td>
	<td bgcolor = FFFFFF height=24 width = 50% align=center valign=middle></td>
	<td bgcolor = FFFFFF height=24 width = 5% align=center valign=middle><a href=viewlinks.php?id=".$id_pressed."&sort=3 title=''></a></td>
	</tr>
	<tr><td bgcolor =000000 height=1></td>
	<td bgcolor = 000000 height=1></td>
	<td bgcolor = 000000 height=1></td>
	<td bgcolor = 000000 height=1></td>
	</tr>";
	
	$i=1;
	
	while ($myrow = mysql_fetch_array($sql_res))
	{
		$name = stripslashes($myrow["linkname"]);
		$descr = stripslashes($myrow["descr"]);
		$email = stripslashes($myrow["authoremail"]);
		$author= stripslashes($myrow["authorname"]);
		$count = $myrow["count_view"];
		$id = $myrow["id"];
				
		if ($i==0) { $i=1; } else { $i=0; }
		
		$result = $result."<tr><td  height=24><div class=main>"
		."<a href=go.php?id=$id target=_blank>$name</a>"
		."</div></td><td height=24><div class=main>"
		."<a href=mailto:$email>$author</a>"
		."</div></td><td height=24><div class=main>"
		."<font size = 1>$descr</font>"
		."</div></td><td height=24><div class=main>"
		."<font size = 1> $count</NOBR></font>";
	}
	$result = $result."</div></td></tr>";
	
	$result = $result."</table>";
	$result = $result."<table width=99% border=0><tr><td align=left>";
	$result = $result.": ";

	for($i=1; $i<=$pages; $i++)
	{
		$next=($i-1)*$onelistcount;
		if ($i == ($startpoint/$onelistcount)+1)
		{
			$result = $result."<b>".$i."</b> ";
		}
		else
		{
			$result = $result."<a href=viewlinks.php?id=$tempid&startpoint=$next&sort=$sort>".$i."</a> ";
		}
	}
	$result = $result."</td></tr></table>";
	return $result;
}

function show_last_links()
{

    $i=0;
    $result="<table width=100%>";

    $res = $this->sql_query("SELECT * from ".$this->prefix."links ORDER BY id DESC LIMIT 0,$this->link_count");
    while (@$myrow = mysql_fetch_array($res))
    {
	$name = stripslashes($myrow["linkname"]);
	$descr = stripslashes($myrow["descr"]);
	$id = $myrow["id"];
	if ($i==0) { $i=1; } else { $i=0; }
	$result=$result."<tr><td height=24><div class = main>"."<a href=go.php?id=$id title='$descr' target = _blank>$name</a><br>"."</div><hr size=1 width=100% NOSHADE align=left color=#a5a5a5></td></tr>";
    }
    $result=$result."</table>";
    return $result;
}

function show_best_links()
{

    $i=0;
    $result="<table width=100% cellspacing=0 cellpadding=0 border=0>";

    $res = $this->sql_query("SELECT id, linkname, descr from ".$this->prefix."links ORDER BY count_view DESC LIMIT 0,$this->link_count");

    while (@$myrow = mysql_fetch_array($res))
    {
	$name = stripslashes($myrow["linkname"]);
	$descr = stripslashes($myrow["descr"]);
	$id = $myrow["id"];
    if ($i==0) { $i=1; } else { $i=0; }
    $result=$result."<tr><td height=24><div class='marg'>"."<a href=go.php?id=$id title='$descr' target = _blank>$name</a>"."</div></td></tr>";
    }
    $result=$result."</table>";
    return $result;
}
//##############################################################################
// 

function show_stats()
{
	$res = $this->sql_query("SELECT COUNT(*) FROM ".$this->prefix."articles");
	$itms_art = mysql_fetch_array($res);
	$res = $this->sql_query("SELECT COUNT(*) FROM ".$this->prefix."files");
	$itms_file = mysql_fetch_array($res);
	$res = $this->sql_query("SELECT COUNT(*) FROM ".$this->prefix."links");
	$itms_link = mysql_fetch_array($res);
	$result="
	<b><u>  </u></b><br>
	c: ".$itms_art[0]."<br>
	: ".$itms_file[0]."<br>
	: ".$itms_link[0];
	return $result;
}



function show_blog()
{
	$result = "<table width=100% cellspacing=0 cellpadding = 0 border = 0 class=blog>";
	$result = $result."<tr><td><a href=addblog.php>   </a></tr></td>";	
	$res = $this->sql_query("SELECT * from ".$this->prefix."blog WHERE approved=1 ORDER BY id DESC LIMIT 0,".$this->blog_show);
	$this->notags_init();

	while (@$myrow = mysql_fetch_array($res))
	{
		$result = $result."<tr><td height=25 class=blog>";
		
		$data = $myrow["data"];
		$author = stripslashes($myrow["author"]);
		$id = $myrow["id"];
		$title=stripslashes($myrow["title"]);
		$descript=stripslashes($myrow["descript"]);
		$descript = $this->notags_correct($descript);	
		$descript = str_replace("\r\n","<br>\n","$descript");
		$count=$myrow["viewcount"];
	
		$descript =  stripslashes($descript);
		$result = $result.":".$data." :".$count."</td></tr><tr><td height=25 class=blog>";
		$result = $result.":".$author."</td></tr><tr><td height=25 class=blog>";
		$result = $result."<b><u>".$title."</u></b></td></tr><tr><td class=blog>";
		$result = $result.$descript;
		$result = $result."</td></tr>";
		$result = $result."<tr><td>";
		$result = $result."<a href=viewblog.php?id=$id></a>";
		$result = $result."</td></tr>";
		$result = $result."<tr><td class=blog><hr size=1 color=a5a5a5 NOSHADE width=100%></td></tr>";
	}	
	
	$result = $result."<tr><td class=blog><a href=addblog.php>   </a></tr></td>";
	$result = $result."</table>";
	return $result;
}

function view_blog()
{
	$result = "<table width=700 cellspacing=0 cellpadding = 0 border = 0 class=blog>";
	$res = $this->sql_query("SELECT * from ".$this->prefix."blog WHERE id=$this->blog_id AND approved=1");

	$this->notags_init();

	while (@$myrow = mysql_fetch_array($res))
	{
		$result = $result."<tr><td height=25 class=blog>";
		$data = $myrow["data"];
		$author = stripslashes($myrow["author"]);
		$id = $myrow["id"];
		$title=stripslashes($myrow["title"]);
		$descript=stripslashes($myrow["descript"]);
		$post = $myrow["post"];
		$descript = $this->notags_correct($descript);	
		$descript = str_replace("\r\n","<br>\n","$descript");
		$post = $this->notags_correct($post);	
		$post = str_replace("\r\n","<br>\n","$post");
		$count=$myrow["viewcount"];
	
		$count=$count+1;
		$sql_query = "UPDATE ".$this->prefix."blog SET viewcount='$count' WHERE id=".$id;
		$sql_res=$this->sql_query($sql_query);
		
		$descript =  stripslashes($descript);
		$post= stripslashes($post);
		$result = $result.":".$data." :".$count."</td></tr><tr><td height=25 class=blog>";
		$result = $result.":".$author."</td></tr><tr><td height=25 class=blog>";
		$result = $result."<b><u>".$title."</u></b></td></tr><tr><td class=blog>";
		$result = $result.$descript;
		$result = $result."<hr size=1 width=40% color=a5a5a5 NOSHADE>";
		$result = $result."</td></tr>";
		$result = $result."<tr><td>";
		$result = $result.$post;
		$result = $result."</td></tr>";
		$result = $result."<tr><td class=blog></td></tr>";
	}	
	$result = $result."<tr><td class=blog>";
	$res = $this->sql_query("SELECT COUNT(*) FROM ".$this->prefix."blog WHERE id < $this->blog_id AND approved=1");
	echo $this->sql_err;
	$itms = mysql_fetch_array($res);
	$total = $itms[0];
		
		
	if ($total == 0)
	{
		$result = $result."[]";
	} 
	else
	{
		$res = $this->sql_query("SELECT id FROM ".$this->prefix."blog WHERE id < $this->blog_id ORDER BY id DESC");
		$myrow = mysql_fetch_array($res);
		$id = $myrow["id"];
		$result = $result."[<a href=viewblog.php?id=".$id."></a>]";
	}
	
	$res = $this->sql_query("SELECT COUNT(*) FROM ".$this->prefix."blog WHERE id > $this->blog_id AND approved=1");
	echo $this->sql_err;
	$itms = mysql_fetch_array($res);
	$total = $itms[0];
		
		
	if ($total == 0)
	{
		$result = $result."[]";
	} 
	else
	{
		$res = $this->sql_query("SELECT id FROM ".$this->prefix."blog WHERE id > $this->blog_id ORDER BY id ASC");
		$myrow = mysql_fetch_array($res);
		$id = $myrow["id"];
		$result = $result."[<a href=viewblog.php?id=".$id."></a>]";
	}
	$result = $result."</td></tr>";	
	
	$result = $result."</table>";
	
	return $result;
}

}; // End of class

$site= new site;

?>