<?php
/**
* @author     MOPO3 <MOPO3@freemail.lt>
* @desc       Class to generate XML and RSS files (export data in XML or RSS format)
* @copyright   " ", All rights reserved
**/

error_reporting(E_ALL & ~E_NOTICE);
require_once("defs.php");
require_once("../config.php");
$file_path = $path;
$sort_type = "DESC"; //possible values ASC, DESC
$limit = 10; //if empty then All data

$link = mysql_connect($sql_host, $sql_login, $sql_passwd);
mysql_select_db($sql_dbname, $link);

class xml_rss_export
{
	/**
	* @desc Class constructor
	* @param void
	* @return void
	**/
	function xml_rss_export()
	{		
	}	
	
	/**
	* @param 	string $sql  (SQL query) 
	* @return 	XML source generated from sql result
	* @example  export_xml_links($sql)
	**/
	function export_xml_links($sql) 
	{
		$xml  = "<?xml version=\"1.0\" encoding=\"windows-1251\" ?>\n";
		$xml .= "<LINKS>\n"; //Root tag
		$count = 1;
		
		//$res = $this->sql_query($sql);
		$res = mysql_query($sql);
		if(!$res) { 
			$xml .= "<error>".mysql_error()."</error>\n"; 
		} else if(mysql_num_rows($res) < 1) {
			$xml .= "<error>No results</error>\n";
	    } else {
			while($row = mysql_fetch_array($res)) {
				$xml .= "<record id=\"".$count."\">\n";
				$xml .= "<category>".$this->replace_chars("{$row['category']}")."</category>";
				$xml .= "<cat_description>".$this->replace_chars("{$row['cat_description']}")."</cat_description>";
				$xml .= "<linkname>".$this->replace_chars("{$row['linkname']}")."</linkname>";
				$xml .= "<link_description>".$this->replace_chars("{$row['link_description']}")."</link_description>";
				$xml .= "<url>".$this->replace_chars("{$row['url']}")."</url>";
				$xml .= "<authorname>".$this->replace_chars("{$row['authorname']}")."</authorname>";
				$xml .= "<authoremail>".$this->replace_chars("{$row['authoremail']}")."</authoremail>";
				$xml .= "<views>".$this->replace_chars("{$row['views']}")."</views>";
				$xml .= "</record>\n";
				$count++;
			}
		}
		
		$xml .= "</LINKS>\n"; //End of Root tag
		
		return $xml;
	}
	
	/**
	* @param 	string $sql  (SQL query) 
	* @return 	XML source generated from sql result
	* @example  export_xml_files($sql)
	**/
	function export_xml_files($sql) 
	{
		$xml  = "<?xml version=\"1.0\" encoding=\"windows-1251\" ?>\n";
		$xml .= "<FILES>\n"; //Root tag
		$count = 1;
		
		//$res = $this->sql_query($sql);
		$res = mysql_query($sql);
		if(!$res) { 
			$xml .= "<error>".mysql_error()."</error>\n"; 
		} else if(mysql_num_rows($res) < 1) {
			$xml .= "<error>No results</error>\n";
	    } else {
			while($row = mysql_fetch_array($res)) {
				$xml .= "<record id=\"".$count."\">\n";
				$xml .= "<category>".$this->replace_chars("{$row['category']}")."</category>";
				$xml .= "<cat_description>".$this->replace_chars("{$row['cat_description']}")."</cat_description>";
				$xml .= "<filename>".$this->replace_chars("{$row['filename']}")."</filename>";
				$xml .= "<file_description>".$this->replace_chars("{$row['file_description']}")."</file_description>";
				$xml .= "<url>".$this->replace_chars("{$row['url']}")."</url>";
				$xml .= "<authorname>".$this->replace_chars("{$row['authorname']}")."</authorname>";
				$xml .= "<authoremail>".$this->replace_chars("{$row['authoremail']}")."</authoremail>";
				$xml .= "<views>".$this->replace_chars("{$row['views']}")."</views>";
				$xml .= "</record>\n";
				$count++;
			}
		}
		
		$xml .= "</FILES>\n"; //End of Root tag
		
		return $xml;
	}
	
	/**
	* @param 	string $sql  (SQL query) 
	* @return 	XML source generated from sql result
	* @example  export_xml_articles($sql)
	**/
	function export_xml_article($sql) 
	{
		$xml  = "<?xml version=\"1.0\" encoding=\"windows-1251\" ?>\n";
		$xml .= "<ARTICLES>\n"; //Root tag
		$count = 1;
		
		//$res = $this->sql_query($sql);
		$res = mysql_query($sql);
		if(!$res) { 
			$xml .= "<error>".mysql_error()."</error>\n"; 
		} else if(mysql_num_rows($res) < 1) {
			$xml .= "<error>No results</error>\n";
	    } else {
			while($row = mysql_fetch_array($res)) {
				$xml .= "<record id=\"".$count."\">\n";
				$xml .= "<category>".$this->replace_chars("{$row['category']}")."</category>";
				$xml .= "<cat_description>".$this->replace_chars("{$row['cat_description']}")."</cat_description>";
				$xml .= "<article_name>".$this->replace_chars("{$row['article_name']}")."</article_name>";
				$xml .= "<article_description>".$this->replace_chars("{$row['article_description']}")."</article_description>";
				$xml .= "<authorname>".$this->replace_chars("{$row['authorname']}")."</authorname>";
				$xml .= "<authoremail>".$this->replace_chars("{$row['authoremail']}")."</authoremail>";
				$xml .= "<views>".$this->replace_chars("{$row['views']}")."</views>";
				$xml .= "</record>\n";
				$count++;
			}
		}
		
		$xml .= "</ARTICLES>\n"; //End of Root tag
		
		return $xml;
	}
	
	/**
	* @param 	string $sql  (SQL query) 
	* @return 	XML source generated from sql result
	* @example  export_xml_blog($sql)
	**/
	function export_xml_blog($sql) 
	{
		$xml  = "<?xml version=\"1.0\" encoding=\"windows-1251\" ?>\n";
		$xml .= "<BLOG>\n"; //Root tag
		$count = 1;
		
		//$res = $this->sql_query($sql);
		$res = mysql_query($sql);
		if(!$res) { 
			$xml .= "<error>".mysql_error()."</error>\n"; 
		} else if(mysql_num_rows($res) < 1) {
			$xml .= "<error>No results</error>\n";
	    } else {
			while($row = mysql_fetch_array($res)) {
				$xml .= "<record id=\"".$count."\">\n";
				$xml .= "<data>".$this->replace_chars("{$row['data']}")."</data>";
				$xml .= "<author>".$this->replace_chars("{$row['author']}")."</author>";
				$xml .= "<title>".$this->replace_chars("{$row['title']}")."</title>";
				$xml .= "<description>".$this->replace_chars("{$row['description']}")."</description>";
				$xml .= "<views>".$this->replace_chars("{$row['views']}")."</views>";
				$xml .= "</record>\n";
				$count++;
			}
		}
		
		$xml .= "</BLOG>\n"; //End of Root tag
		
		return $xml;
	}
	
	/**
	* @param 	string $sql  (SQL query) 
	* @param 	string $link  (Link where the info is)
	* @param 	string $description (Description of the current link)
	* @return 	RSS source generated from sql result
	* @example  export_rss_links($sql, "http://club.shelek.com/viewlinks.php", "  ' '")
	**/
	function export_rss_links($sql, $link, $description)
	{
		$rss  = "<?xml version=\"1.0\" encoding=\"windows-1251\" ?>\n";
		$rss .= "<rss version=\"2.0\">\n";
		$rss .= "<channel>\n";
		$rss .= "<title>  ' '</title>\n"; 
		$rss .= "<link>".$link."</link>\n"; 
		$rss .= "<description>".$description."</description>\n"; 
		$rss .= "<copyright> Copyright ' ' 2002-".date("Y")."</copyright>\n"; 
		$rss .= "<webMaster>club@shelek.com</webMaster>\n"; 
		$rss .= "<lastBuildDate>".date("F j, Y, g:i a")."</lastBuildDate>\n";

		//$res = $this->sql_query($sql);
		$res = mysql_query($sql);
		if(!$res) {
			$rss .= "<item>\n";
			$rss .= "<title>".mysql_error()."</title>\n"; 
			$rss .= "</item>\n";
		} else if(mysql_num_rows($res) < 1) {
			$rss .= "<item>\n";
			$rss .= "<title>No results</title>\n"; 
			$rss .= "</item>\n";
		} else {
			while($row = mysql_fetch_array($res)) {
				$rss .= "<item>\n";
				$rss .= "<title>".$this->replace_chars("{$row['title']}")."</title>\n";
				$rss .= "<link>".$this->replace_chars("{$row['link']}")."</link>\n";
				$rss .= "<description>".$this->replace_chars("{$row['description']}")."</description>\n";
				$rss .= "<author>".$this->replace_chars("{$row['author']}")." (".$this->replace_chars("{$row['authoremail']}").")</author>";
				$category = "{$row['category']}";
				if(empty($category) || $category == "") {
					$rss .= "</category>";
				} else {
					$rss .= "<category>".$this->replace_chars("{$row['category']}")."</category>";
				}
				$rss .= "</item>\n";
			}
		}
		
		$rss .= "</channel>\n";
		$rss .= "</rss>\n";
		
		return $rss;
	}
	
	/**
	* @param 	string $sql  (SQL query) 
	* @param 	string $link  (Link where the info is)
	* @param 	string $description (Description of the current link)
	* @return 	RSS source generated from sql result
	* @example  export_rss_files($sql, "http://club.shelek.com/viewfiles.php", "  ' '")
	**/
	function export_rss_files($sql, $link, $description)
	{
		$rss  = "<?xml version=\"1.0\" encoding=\"windows-1251\" ?>\n";
		$rss .= "<rss version=\"2.0\">\n";
		$rss .= "<channel>\n";
		$rss .= "<title>  ' '</title>\n"; 
		$rss .= "<link>".$link."</link>\n"; 
		$rss .= "<description>".$description."</description>\n"; 
		$rss .= "<copyright> Copyright ' ' 2002-".date("Y")."</copyright>\n"; 
		$rss .= "<webMaster>club@shelek.com</webMaster>\n"; 
		$rss .= "<lastBuildDate>".date("F j, Y, g:i a")."</lastBuildDate>\n";

		//$res = $this->sql_query($sql);
		$res = mysql_query($sql);
		if(!$res) {
			$rss .= "<item>\n";
			$rss .= "<title>".mysql_error()."</title>\n"; 
			$rss .= "</item>\n";
		} else if(mysql_num_rows($res) < 1) {
			$rss .= "<item>\n";
			$rss .= "<title>No results</title>\n"; 
			$rss .= "</item>\n";
		} else {
			while($row = mysql_fetch_array($res)) {
				$rss .= "<item>\n";
				$rss .= "<title>".$this->replace_chars("{$row['title']}")."</title>\n";
				$rss .= "<link>".$this->replace_chars("{$row['link']}")."</link>\n";
				$rss .= "<description>".$this->replace_chars("{$row['description']}")."</description>\n";
				$rss .= "<author>".$this->replace_chars("{$row['author']}")." (".$this->replace_chars("{$row['authoremail']}").")</author>";
				$category = "{$row['category']}";
				if(empty($category)) {
					$rss .= "</category>";
				} else {
					$rss .= "<category>".$this->replace_chars("{$row['category']}")."</category>";
				}
				$rss .= "</item>\n";
			}
		}
		
		$rss .= "</channel>\n";
		$rss .= "</rss>\n";
		
		return $rss;
	}
	
	/**
	* @param 	string $sql  (SQL query) 
	* @param 	string $link  (Link where the info is)
	* @param 	string $description (Description of the current link)
	* @return 	RSS source generated from sql result
	* @example  export_rss_articles($sql, "http://club.shelek.com/view.php", "  ' '")
	**/
	function export_rss_articles($sql, $link, $description)
	{
		$rss  = "<?xml version=\"1.0\" encoding=\"windows-1251\" ?>\n";
		$rss .= "<rss version=\"2.0\">\n";
		$rss .= "<channel>\n";
		$rss .= "<title>  ' '</title>\n"; 
		$rss .= "<link>".$link."</link>\n"; 
		$rss .= "<description>".$description."</description>\n"; 
		$rss .= "<copyright> Copyright ' ' 2002-".date("Y")."</copyright>\n"; 
		$rss .= "<webMaster>club@shelek.com</webMaster>\n"; 
		$rss .= "<lastBuildDate>".date("F j, Y, g:i a")."</lastBuildDate>\n";

		//$res = $this->sql_query($sql);
		$res = mysql_query($sql);
		if(!$res) {
			$rss .= "<item>\n";
			$rss .= "<title>".mysql_error()."</title>\n"; 
			$rss .= "</item>\n";
		} else if(mysql_num_rows($res) < 1) {
			$rss .= "<item>\n";
			$rss .= "<title>No results</title>\n"; 
			$rss .= "</item>\n";
		} else {
			while($row = mysql_fetch_array($res)) {
				$rss .= "<item>\n";
				$rss .= "<title>".$this->replace_chars("{$row['title']}")."</title>\n";
				$rss .= "<description>".$this->replace_chars("{$row['description']}")."</description>\n";
				$rss .= "<author>".$this->replace_chars("{$row['author']}")." (".$this->replace_chars("{$row['authoremail']}").")</author>";
				$category = "{$row['category']}";
				if(empty($category) || $category == "") {
					$rss .= "</category>";
				} else {
					$rss .= "<category>".$this->replace_chars("{$row['category']}")."</category>";
				}
				$rss .= "</item>\n";
			}
		}
		
		$rss .= "</channel>\n";
		$rss .= "</rss>\n";
		
		return $rss;
	}
	
	/**
	* @param 	string $sql  (SQL query) 
	* @param 	string $link  (Link where the info is)
	* @param 	string $description (Description of the current link)
	* @return 	RSS source generated from sql result
	* @example  export_rss_articles($sql, "http://club.shelek.com/", "  ' '")
	**/
	function export_rss_blog($sql, $link, $description)
	{
		$rss  = "<?xml version=\"1.0\" encoding=\"windows-1251\" ?>\n";
		$rss .= "<rss version=\"2.0\">\n";
		$rss .= "<channel>\n";
		$rss .= "<title>  ' '</title>\n"; 
		$rss .= "<link>".$link."</link>\n"; 
		$rss .= "<description>".$description."</description>\n"; 
		$rss .= "<copyright> Copyright ' ' 2002-".date("Y")."</copyright>\n"; 
		$rss .= "<webMaster>club@shelek.com</webMaster>\n"; 
		$rss .= "<lastBuildDate>".date("F j, Y, g:i a")."</lastBuildDate>\n";

		//$res = $this->sql_query($sql);
		$res = mysql_query($sql);
		if(!$res) {
			$rss .= "<item>\n";
			$rss .= "<title>".mysql_error()."</title>\n"; 
			$rss .= "</item>\n";
		} else if(mysql_num_rows($res) < 1) {
			$rss .= "<item>\n";
			$rss .= "<title>No results</title>\n"; 
			$rss .= "</item>\n";
		} else {
			while($row = mysql_fetch_array($res)) {
				$rss .= "<item>\n";
				$rss .= "<title>".$this->replace_chars("{$row['title']}")."</title>\n";
				$rss .= "<description>".$this->replace_chars("{$row['description']}")."</description>\n";
				$rss .= "<author>".$this->replace_chars("{$row['author']}")."</author>";
				$rss .= "<pubDate>".$this->replace_chars("{$row['pubDate']}")."</pubDate>";
				$rss .= "</item>\n";
			}
		}
		
		$rss .= "</channel>\n";
		$rss .= "</rss>\n";
		
		return $rss;
	}
	
	/**
	* @param   string $path (Path where to save xml file)
	* @param   string $filename (Name of file to be saved)
	* @param   string $src (XML or RSS source to be saved)
	* @example save_xml_file("/usr/home/www/newclub/xmlfeeds/", "links.xml")
	* @example save_xml_file("/usr/home/www/newclub/xmlfeeds/", "links.rss.xml")
	**/
	function save_xml_file($path, $filename, $src) 
	{
		$handle = fopen($path.$filename, "w+");
		fwrite($handle, $src);
		fclose($handle);
	}
	
	/**
	* @param    string source
	* @return   string source (with replaced special characters)
	* @example  replace_chars($row)
	**/
	function replace_chars($str_src) { // Basic XML entities
		$str_src = str_replace("&", "&#38;", $str_src);
		$str_src = str_replace("'", "&#39;", $str_src);
		$str_src = str_replace('"', "&#34;", $str_src);
		$str_src = str_replace("<", "&#60;", $str_src);
		$str_src = str_replace(">", "&#62;", $str_src);
/*
		$str_src = str_replace("&", "and", $str_src);
		$str_src = str_replace("%", "percent", $str_src);
		$str_src = str_replace("<a href=", "", $str_src);
		$str_src = str_replace("</a>", "", $str_src);
		$str_src = str_replace("<", "", $str_src);
		$str_src = str_replace(">", "", $str_src);
*/		
		return $str_src;
	}
}
global $prefix;
/******************************************** SQL Queries ************************************************/
if(empty($limit)) { $sql_limit = ""; } else { $sql_limit = "LIMIT ".$limit.""; }
$sql_xml_links = "SELECT a.linkname, a.url, a.descr AS link_description, a.authorname, a.authoremail, a.count_view AS views, b.name AS category, b.descr AS cat_description FROM ".$prefix."links AS a, ".$prefix."linktopics AS b WHERE a.id_topic = b.id ORDER BY a.id ".$sort_type." ".$sql_limit."";
$sql_xml_files = "SELECT a.filename, a.url, a.descr AS file_description, a.authorname, a.authoremail, a.count_view AS views, b.name AS category, b.descr AS cat_description FROM ".$prefix."files AS a, ".$prefix."filetopics AS b WHERE a.id_topic = b.id ORDER BY a.id ".$sort_type." ".$sql_limit."";
$sql_xml_articles = "SELECT a.nameoftxt AS article_name, a.descript AS article_description, a.authorname, a.authoremail, a.count_view AS views, b.name AS category, b.descr AS cat_description FROM ".$prefix."articles AS a, ".$prefix."topics AS b WHERE a.id_topics = b.id ORDER BY a.id ".$sort_type." ".$sql_limit."";
$sql_xml_blog = "SELECT  data, author, title AS title, descript AS description, viewcount AS views FROM ".$prefix."blog ORDER BY id ".$sort_type." ".$sql_limit."";
$sql_rss_blog = "SELECT  data AS pubDate, author, title AS title, descript AS description FROM ".$prefix."blog ORDER BY id ".$sort_type." ".$sql_limit."";
$sql_rss_articles = "SELECT a.nameoftxt AS title, a.descript AS description, a.authorname AS author, a.authoremail AS authoremail, b.name AS category FROM ".$prefix."articles AS a, ".$prefix."topics AS b WHERE a.id_topics = b.id ORDER BY a.id ".$sort_type." ".$sql_limit."";
$sql_rss_links = "SELECT a.linkname AS title, a.url AS link, a.descr AS description, a.authorname AS author, a.authoremail AS authoremail, b.name AS category FROM ".$prefix."links AS a, ".$prefix."linktopics AS b WHERE a.id_topic = b.id ORDER BY a.id ".$sort_type." ".$sql_limit."";
$sql_rss_files = "SELECT a.filename AS title, a.url AS link, a.descr AS description, a.authorname AS author, a.authoremail AS authoremail, b.name AS category FROM ".$prefix."files AS a, ".$prefix."filetopics AS b WHERE a.id_topic = b.id ORDER BY a.id ".$sort_type." ".$sql_limit."";
/***********************************************************************************************************/
/*
$obj = new xml_rss_export;
$data = $obj->export_xml_links($sql_xml_links);
$obj->save_xml_file($file_path, "links.xml", $data);
$data2 = $obj->export_rss_links($sql_rss_links, "http://club.shelek.com/viewlinks.php", "  ' '");
$obj->save_xml_file($file_path, "links.rss.xml", $data2);
$data3 = $obj->export_xml_files($sql_xml_files);
$obj->save_xml_file($file_path, "files.xml", $data3);
$data4 = $obj->export_rss_files($sql_rss_files, "http://club.shelek.com/viewfiles.php", "  ' '");
$obj->save_xml_file($file_path, "files.rss.xml", $data4);
$data5 = $obj->export_xml_article($sql_xml_articles);
$obj->save_xml_file($file_path, "articles.xml", $data5);
$data6 = $obj->export_rss_articles($sql_rss_articles, "http://club.shelek.com/view.php", "  ' '");
$obj->save_xml_file($file_path, "articles.rss.xml", $data6);
$data7 = $obj->export_xml_blog($sql_xml_blog);
$obj->save_xml_file($file_path, "blog.xml", $data7);
$data8 = $obj->export_rss_blog($sql_rss_blog, "http://club.shelek.com/", "  ' '");
$obj->save_xml_file($file_path, "blog.rss.xml", $data8);
unset($obj);
mysql_close($link);
*/
?>